
  # 11-1-99 
  # Compute the P-values for the sieve likelihood test. 
  # We use Epanechnikov kernel and local linear fitting method
  # USE THE TESTING PROCEDURE TO TEST 
  # THE FUNCTIONAL-COEFFICIENT MODEL AGAINST TAR MODEL OR AR(2) MODEL

  # In order to run this sprogram, you have to input nb=, which model?
  nb<-200             # set the number of bootstraps
  model<-0            # model=1, FC vs TAR; model=0, FC vs AR(2)
  
  bootstrap<-1        # do bootstrap ?
  if(model==0){print(c("TEST FC vs AR(2)"))}
  if(model==1){print(c("TEST FC vs TAR"))}
  h<-1.00            
  p.value<-0
  print(c("Bandwidth is", h))
  print(c("THE NUMBER OF BOOTSTRAP IS", nb))

#################
#DEFINE FUNCTIONS
#################

#############################################################################  
  # Define the kernel function and the coefficient functions for TAR model
  kernel<-function(x){0.75*(1-x^2)*(abs(x)<=1)} 
  a0<-function(x){0.62*(x<=3.25)+2.25*(x>3.25)}
  a1<-function(x){1.25*(x<=3.25)+1.52*(x>3.25)} 
  a2<-function(x){-0.43*(x<=3.25)-1.24*(x>3.25)}
    
  # Define the local linear fitting 
  localfit<-function(y,x1,x2,u,u0,h){
  ngrid<-length(u0)
  beta<-rep(0,ngrid*2)
  dim(beta)<-c(ngrid,2)
  for (k in 1:ngrid){
    xu1<-x1*(u-u0[k])
    xu2<-x2*(u-u0[k])
    w0<-kernel((u-u0[k])/h)/h+0.0001                  
    mydata<-data.frame(y,x1,x2,xu1,xu2,w0)
    fit<-glm(y~-1+x1+x2+xu1+xu2,family=gaussian,data=mydata,weights=w0)
    beta[k,]<-coef(fit)[1:2]}
    beta
  }
#############################################################################   
    

##########################################
#COMPUTE THE TEST STATISTIC
##########################################

#############################################################################
  n<-length(fig111.data)
  y<-fig111.data[3:n]                # Y_t
  u<-fig111.data[1:(n-2)]            # U_t
  x1<-fig111.data[2:(n-1)]           # X_{1t}
  x2<-fig111.data[1:(n-2)]           # X_{2t}
  if(model==0){
  arfit<-ar(fig111.data,order=2)      # AR(2) fitting
  y0<-y-arfit$resid[3:n]}     # fitted vector from AR(2) model
  if(model==1){y0<-a0(u)+a1(u)*x1+a2(u)*x2}    # fitted vector from TAR model                                 
                                 
  beta<-localfit(y,x1,x2,u,u,h)  # compute the estimate of a_1(u) and a_2(u)
  y1<-beta[,1]*x1+beta[,2]*x2    # fitted vector from FC model
  epsilon0<-y-y1-mean(y-y1)      # centerized nonparamteric residual vector
  rss0<-mean((y-y0)^2)           # RSS_0 
  rss1<-mean((y-y1)^2)           # RSS_1
  tn<-log(rss0/rss1) *(n-2)/2    # test statistic T_n
  print(c("THE OBSERVED VALUE of RSS0 is", rss0))
  print(c("THE OBSERVED VALUE of RSS1 is", rss1))
  print(c("THE OBSERVED VALUE of t_n is", tn))
  
#############################################################################


#################
#BOOSTRAP LOOP
################

#############################################################################
   if(bootstrap==1){
   print(c("NOW, WE BEGIN BOOTSTRAP"))
   for(b in 1:nb){
   epsilon.star<-sample(epsilon0, rep=T)  
     # resampling from the nonparametric residuals
   ystar<-y0+epsilon.star                 # compute the bootstrap samples
   rss0<-mean((epsilon.star)^2)           # RSS_0^*
   beta<-localfit(ystar,x1,x2,u,u,h)      
     # compute the estimate of a_1(u) and a_2(u) based on the bootstrap samples
   y1<-beta[,1]*x1+beta[,2]*x2       # fitted vector based on bootstrap samples
   rss1<-mean((ystar-y1)^2)          # RSS_1
   tnstar<-log(rss0/rss1)*(n-2)/2       # T_n^*   
   if(tnstar>=tn){p.value<-p.value+1}   # compute the rejection number
   print(c(b, "THE NUMBER of REJECTION", p.value))
   }                                 # the end of the BOOTSTRAP loop
   p.value<-p.value/nb               # compute the relative frequency
   if(model==0){print(c("THE P-VALUE for FC vs AR(2) is", p.value))}
   if(model==1){print(c("THE P-VALUE for FC vs TAR is", p.value))}
   print(b)
   }                                 # end of bootstrap=1
 #############################################################################
 
